//
//  OTPSOCK
//
//	Copyright (C) 1996-1999 NEC Corporation
//	All rights reserved.
//  Authos(s): Mizukoshi, Yasuhiro <mizukosi@ccs.mt.nec.co.jp>
//

//	    $Archive: /sotools/otpsock/common.h $
//			$Revision: 2 $
//			$Date: 99/01/06 11:54a $

#ifdef WIN32
#define EXPORT
#else
#define EXPORT _export
#endif

#ifdef WIN32
#define MALLOC	malloc
#define FREE	free
#define MEMCPY	memcpy
#else
#define MALLOC	_fmalloc
#define FREE	_ffree
#define MEMCPY	_fmemcpy
#endif

#ifdef _DEBUG
#define	x_OutputDebugString(x)	OutputDebugString(x)
#else
#define	x_OutputDebugString(x)
#endif

#define PASS_PHRASE_MIN_LEN	8
#define PASS_PHRASE_MAX_LEN	256
#define	SEED_MAX_LEN		1024
#define	ONETIME_KEY_MAX_LEN	256

#define SEQSEED_POS			" %d %s"

#define FUNCNAME_MD2		"md2"
#define FUNCNAME_MD4		"md4"
#define FUNCNAME_MD5		"md5"
#define FUNCNAME_SHA1		"sha1"

#define	OTPCALC_SERVER_TMPL	"otp-%s %d %s"

#define MD2					0
#define MD4					1
#define MD5					2
#define SHA1				3

#define FTP_MODE			1
#define TELNET_MODE			2

extern char *OTP_btoe(char *, char *);

extern int  _otp_MD4_keycrunch(char *, char *, char *);
extern void _otp_MD4_iterate(char *);
extern int  _otp_MD5_keycrunch(char *, char *, char *);
extern void _otp_MD5_iterate(char *);
extern int  _otp_SHA1_keycrunch(char *result, char *seed, char *passwd);
extern void _otp_SHA1_iterate(char *x);

#define	FTP_RESPONSE			"331 "

struct KeywordPattern {
	char *key;
	int  func;
	BOOL IsSKey;
};

int otpmain(SOCKET s, char FAR * buf, int len, int flags);
int SendPassMode(const struct sockaddr FAR *name, int namelen);
int CheckSeqNum();

int PASCAL FAR otp_connect (SOCKET s, const struct sockaddr FAR *name, int namelen);
int PASCAL FAR otp_recv (SOCKET s, char FAR * buf, int len, int flags);
int PASCAL FAR otp_send (SOCKET s, const char FAR * buf, int len, int flags);

#define	DEFAULT_OTPCALC			"DOTKEY95"

#define OTPSOCK_SUBKEY			"Software\\NEC\\WinSock\\otpsock"
#define	OTPCALC_VALNAME			"OTPCalcWndName"
#define	SKEY_MD5_VALNAME		"bSKeyMD5"
#define	REQ_END_VALNAME			"ChallengeEnd"
#define OTPSOCK_KEYWORDS_SUBKEY	"Software\\NEC\\WinSock\\otpsock\\keywords"
#define	MAX_KEYWORD_LEN			256

int	InitPreferences();

#define	MAX_OTPBUF_SIZE			1024

struct OTPData {
	char	recvbuf[MAX_OTPBUF_SIZE + 1];
	int		recvbuf_pos;

	BOOL	bSendPass;
	int		mode;
	int		hash_func;
	int		seq;
	char	seed[SEED_MAX_LEN];
	char	pass[ONETIME_KEY_MAX_LEN];
	char	FuncName[128];
	int  (* KeyCrunchFunc)(char *, char *, char *);
	void (* IterateFunc)  (char *);
};

struct HookFuncTab {
	int (PASCAL FAR * connect) (SOCKET s, const struct sockaddr FAR * name, int namelen);
	int (PASCAL FAR * recv) (SOCKET s, char FAR * buf, int len, int flags);
	int (PASCAL FAR * send) (SOCKET s, const char FAR * buf, int len, int flags);
};

#ifdef	GLOBAL
#define	EXTERN
#else
#define	EXTERN extern
#endif

EXTERN	struct OTPData			gOTPData;

EXTERN	COPYDATASTRUCT			gCDS;
EXTERN	char					gtbuf[MAX_OTPBUF_SIZE + 1];

EXTERN	char					gOTPCalcWndName[128];
EXTERN	BOOL					gbSKeyMD5;
EXTERN	char					szReqEnd[128];
EXTERN	int						iReqEndLen;
EXTERN	struct HookFuncTab		hook;

EXTERN	HANDLE					ghModule;
