//
//	OTPWSK32
//
//	Copyright (C) 1996-1999 NEC Corporation
//	All rights reserved.
//  Authos(s): Mizukoshi, Yasuhiro <mizukosi@ccs.mt.nec.co.jp>
//
//

static char CopyRightID[] = "Copyright(C) 1996-1999 NEC Corporation. All rights reserved.";

//	    $Archive: /sotools/otpsock/wsock32/otpwsk32.c $
//			$Revision: 3 $
//			$Date: 99/01/06 11:54a $
static char VssID[] = "$Header: /sotools/otpsock/wsock32/otpwsk32.c 3     99/01/06 11:54a Mizukosi $";

//
//	Functions:
//		DllMain
//		LoadWinsock
//		FreeWinsock
//		PassphraseDlgProc
//		SendPassMode
//		SetFuncName
//		chkResp
//		otpmain
//


#include <windows.h>
#include <winsock.h>

#include <stdio.h>

#define	GLOBAL
#include "../common.h"
#include "otpwsk32.h"
#include "resource.h"

extern struct KeywordPattern *optkeys;

////////////////////////////////////////////////////////
//	WSAStartup
//
int PASCAL FAR EXPORT
WSAStartup(WORD wVersionRequired, LPWSADATA lpWSAData)
{
	int ret;
	
x_OutputDebugString("WSAStartup ");

	if (gft.hWinsock == NULL){
		if (LoadWinsock() == FALSE){
			return WSASYSNOTREADY;
		}
	}

	ret = gft.WSAStartup(wVersionRequired, lpWSAData);
	
	return ret;
}


///////////////////////////////////////////////////
//	OTPWSK32 Entry
//
BOOL APIENTRY DllMain(HANDLE hModule, DWORD ul_reason_for_call, LPVOID lpReserved)
{
	struct LocalData		*ld;
	int i;

	switch(ul_reason_for_call){
	case DLL_PROCESS_ATTACH:
		ghModule = hModule;
		TlsIndex = TlsAlloc();

		gft.hWinsock = NULL;

		InitPreferences();

		ld = (struct LocalData *)LocalAlloc(LPTR, sizeof(struct LocalData));
		TlsSetValue(TlsIndex, (LPVOID)ld);
		ld->hWinsock    = gft.hWinsock;
		ld->bInCall     = FALSE;

		gOTPData.recvbuf_pos = 0;
		gOTPData.mode        = 0;
		gOTPData.bSendPass   = FALSE;
		break;

	case DLL_THREAD_ATTACH:
		ld = (struct LocalData *)LocalAlloc(LPTR, sizeof(struct LocalData));
		TlsSetValue(TlsIndex, (LPVOID)ld);
		ld->hWinsock    = LoadLibrary(ORIGINAL_WSOCK32);
		ld->bInCall     = FALSE;
		break;

	case DLL_THREAD_DETACH:
		ld = (struct LocalData *)TlsGetValue(TlsIndex);
		FreeLibrary(ld->hWinsock);
		LocalFree(ld);
		break;

	case DLL_PROCESS_DETACH:
		ld = (struct LocalData *)TlsGetValue(TlsIndex);
		LocalFree(ld);

		if (optkeys){
			for (i = 0; optkeys[i].key != NULL; i++)
				free(optkeys[i].key);
			free(optkeys);
		}

		FreeWinsock();

		TlsFree(TlsIndex);
		break;
	}

	return TRUE;
}


////////////////////////////////////////////////////////
//
//	LoadWinsock
//
int LoadWinsock()
{
	gft.hWinsock = LoadLibrary(ORIGINAL_WSOCK32);

	if (gft.hWinsock == NULL){
		char szWSPath[MAX_PATH];

		if (!GetSystemDirectory(szWSPath, MAX_PATH))
			return FALSE;

		strcat(szWSPath, "\\wsock32.dll");

		gft.hWinsock = LoadLibrary(szWSPath);
	}

	if (gft.hWinsock == NULL)
		return FALSE;

	hook.connect              = (void *)GetProcAddress(gft.hWinsock, "connect");
	hook.recv                 = (void *)GetProcAddress(gft.hWinsock, "recv");
	hook.send                 = (void *)GetProcAddress(gft.hWinsock, "send");

	gft.accept                = (void *)GetProcAddress(gft.hWinsock, "accept");
	gft.bind                  = (void *)GetProcAddress(gft.hWinsock, "bind");
	gft.closesocket           = (void *)GetProcAddress(gft.hWinsock, "closesocket");
	gft.getpeername           = (void *)GetProcAddress(gft.hWinsock, "getpeername");
	gft.getsockname           = (void *)GetProcAddress(gft.hWinsock, "getsockname");
	gft.getsockopt            = (void *)GetProcAddress(gft.hWinsock, "getsockopt");
	gft.htonl                 = (void *)GetProcAddress(gft.hWinsock, "htonl");
	gft.htons                 = (void *)GetProcAddress(gft.hWinsock, "htons");
	gft.inet_addr             = (void *)GetProcAddress(gft.hWinsock, "inet_addr");
	gft.inet_ntoa             = (void *)GetProcAddress(gft.hWinsock, "inet_ntoa");
	gft.ioctlsocket           = (void *)GetProcAddress(gft.hWinsock, "ioctlsocket");
	gft.listen                = (void *)GetProcAddress(gft.hWinsock, "listen");
	gft.ntohl                 = (void *)GetProcAddress(gft.hWinsock, "ntohl");
	gft.ntohs                 = (void *)GetProcAddress(gft.hWinsock, "ntohs");
	gft.recvfrom              = (void *)GetProcAddress(gft.hWinsock, "recvfrom");
	gft.select                = (void *)GetProcAddress(gft.hWinsock, "select");
	gft.sendto                = (void *)GetProcAddress(gft.hWinsock, "sendto");
	gft.setsockopt            = (void *)GetProcAddress(gft.hWinsock, "setsockopt");
	gft.socket                = (void *)GetProcAddress(gft.hWinsock, "socket");
	gft.shutdown              = (void *)GetProcAddress(gft.hWinsock, "shutdown");

	gft.gethostbyaddr         = (void *)GetProcAddress(gft.hWinsock, "gethostbyaddr");
	gft.gethostbyname         = (void *)GetProcAddress(gft.hWinsock, "gethostbyname");
	gft.getprotobyname        = (void *)GetProcAddress(gft.hWinsock, "getprotobyname");
	gft.getprotobynumber      = (void *)GetProcAddress(gft.hWinsock, "getprotobynumber");
	gft.getservbyname         = (void *)GetProcAddress(gft.hWinsock, "getservbyname");
	gft.getservbyport         = (void *)GetProcAddress(gft.hWinsock, "getservbyport");
	gft.gethostname           = (void *)GetProcAddress(gft.hWinsock, "gethostname");

	gft.WSAAsyncSelect        = (void *)GetProcAddress(gft.hWinsock, "WSAAsyncSelect");
	gft.WSAAsyncGetHostByAddr = (void *)GetProcAddress(gft.hWinsock, "WSAAsyncGetHostByAddr");
	gft.WSAAsyncGetHostByName = (void *)GetProcAddress(gft.hWinsock, "WSAAsyncGetHostByName");
	gft.WSAAsyncGetProtoByNumber = (void *)GetProcAddress(gft.hWinsock, "WSAAsyncGetProtoByNumber");
	gft.WSAAsyncGetProtoByName = (void *)GetProcAddress(gft.hWinsock, "WSAAsyncGetProtoByName");
	gft.WSAAsyncGetServByPort = (void *)GetProcAddress(gft.hWinsock, "WSAAsyncGetServByPort");
	gft.WSAAsyncGetServByName = (void *)GetProcAddress(gft.hWinsock, "WSAAsyncGetServByName");
	gft.WSACancelAsyncRequest = (void *)GetProcAddress(gft.hWinsock, "WSACancelAsyncRequest");
	gft.WSASetBlockingHook    = (void *)GetProcAddress(gft.hWinsock, "WSASetBlockingHook");
	gft.WSAUnhookBlockingHook = (void *)GetProcAddress(gft.hWinsock, "WSAUnhookBlockingHook");
	gft.WSAGetLastError       = (void *)GetProcAddress(gft.hWinsock, "WSAGetLastError");
	gft.WSASetLastError       = (void *)GetProcAddress(gft.hWinsock, "WSASetLastError");
	gft.WSACancelBlockingCall = (void *)GetProcAddress(gft.hWinsock, "WSACancelBlockingCall");
	gft.WSAIsBlocking         = (void *)GetProcAddress(gft.hWinsock, "WSAIsBlocking");
	gft.WSAStartup            = (void *)GetProcAddress(gft.hWinsock, "WSAStartup");
	gft.WSACleanup            = (void *)GetProcAddress(gft.hWinsock, "WSACleanup");

	gft.__WSAFDIsSet          = (void *)GetProcAddress(gft.hWinsock, "__WSAFDIsSet");

	gft.EnumProtocolsA		  = (void *)GetProcAddress(gft.hWinsock, "EnumProtocolsA");
	gft.EnumProtocolsW		  = (void *)GetProcAddress(gft.hWinsock, "EnumProtocolsW");
	gft.GetAddressByNameA	  = (void *)GetProcAddress(gft.hWinsock, "GetAddressByNameA");
	gft.GetAddressByNameW	  = (void *)GetProcAddress(gft.hWinsock, "GetAddressByNameW");
	gft.GetNameByTypeA		  = (void *)GetProcAddress(gft.hWinsock, "GetNameByTypeA");
	gft.GetNameByTypeW		  = (void *)GetProcAddress(gft.hWinsock, "GetNameByTypeW");
	gft.GetServiceA			  = (void *)GetProcAddress(gft.hWinsock, "GetServiceA");
	gft.GetServiceW			  = (void *)GetProcAddress(gft.hWinsock, "GetServiceW");
	gft.GetTypeByNameA		  = (void *)GetProcAddress(gft.hWinsock, "GetTypeByNameA");
	gft.GetTypeByNameW		  = (void *)GetProcAddress(gft.hWinsock, "GetTypeByNameW");
	gft.SetServiceA			  = (void *)GetProcAddress(gft.hWinsock, "SetServiceA");
	gft.SetServiceW			  = (void *)GetProcAddress(gft.hWinsock, "SetServiceW");
	gft.TransmitFile		  = (void *)GetProcAddress(gft.hWinsock, "TransmitFile");
	gft.WSARecvEx			  = (void *)GetProcAddress(gft.hWinsock, "WSARecvEx");

	gft.WsControl             = (void *)GetProcAddress(gft.hWinsock, "WsControl");
	gft.closesockinfo         = (void *)GetProcAddress(gft.hWinsock, "closesockinfo");
	gft.Arecv                 = (void *)GetProcAddress(gft.hWinsock, "Arecv");
	gft.Asend                 = (void *)GetProcAddress(gft.hWinsock, "Asend");
	gft.WSHEnumProtocols      = (void *)GetProcAddress(gft.hWinsock, "WSHEnumProtocols");
	gft.inet_network          = (void *)GetProcAddress(gft.hWinsock, "inet_network");
	gft.getnetbyname          = (void *)GetProcAddress(gft.hWinsock, "getnetbyname");
	gft.rcmd                  = (void *)GetProcAddress(gft.hWinsock, "rcmd");
	gft.rexec                 = (void *)GetProcAddress(gft.hWinsock, "rexec");
	gft.rresvport             = (void *)GetProcAddress(gft.hWinsock, "rresvport");
	gft.sethostname           = (void *)GetProcAddress(gft.hWinsock, "sethostname");
	gft.dn_expand             = (void *)GetProcAddress(gft.hWinsock, "dn_expand");
	gft.s_perror              = (void *)GetProcAddress(gft.hWinsock, "s_perror");
	gft.NPLoadNameSpaces      = (void *)GetProcAddress(gft.hWinsock, "NPLoadNameSpaces");

x_OutputDebugString("END: LoadWinsock\n");

	return TRUE;
}


//////////////////////////////////////////////////////////////
//
//	FreeWinsock
//
int FreeWinsock()
{
	FreeLibrary(gft.hWinsock);

x_OutputDebugString("FreeWinsock\n");

	return TRUE;
}
