//
//	OTPWSK32
//
//	Copyright (C) 1996-1999 NEC Corporation
//	All rights reserved.
//  Authos(s): Mizukoshi, Yasuhiro <mizukosi@ccs.mt.nec.co.jp>
//

//	    $Archive: /sotools/otpsock/wsock32/otpwsk32.h $
//			$Revision: 3 $
//			$Date: 99/01/06 11:54a $

#include	<nspapi.h>
#include	<wtypes.h>

#define	ORIGINAL_WSOCK32	"ws_otp.dll"

int LoadWinsock();
int FreeWinsock();

struct FunctionTable {
	HANDLE		hWinsock;

	SOCKET(PASCAL FAR * accept) (SOCKET s, struct sockaddr FAR * addr, int FAR * addrlen);
	int (PASCAL FAR * bind) (SOCKET s, const struct sockaddr FAR * addr, int namelen);
	int (PASCAL FAR * closesocket) (SOCKET s);
	int (PASCAL FAR * getsockname) (SOCKET s, struct sockaddr FAR * name, int FAR * namelen);
	u_short(PASCAL FAR * htons) (u_short hostshort);
	u_long(PASCAL FAR * htonl) (u_long hostlong);
	unsigned long (PASCAL FAR * inet_addr) (const char FAR * cp);
	int (PASCAL FAR * listen) (SOCKET s, int backlog);
	u_short(PASCAL FAR * ntohs) (u_short netshort);
	SOCKET(PASCAL FAR * socket) (int af, int type, int protocol);
	struct hostent FAR *(PASCAL FAR * gethostbyaddr) (const char FAR * addr, int len, int type);
	struct hostent FAR *(PASCAL FAR * gethostbyname) (const char FAR * name);
	int (PASCAL FAR * gethostname) (char FAR * name, int namelen);
	int (PASCAL FAR * WSAStartup) (WORD wVersionRequired, LPWSADATA lpWSAData);
	int (PASCAL FAR * WSACleanup) (void);
	int (PASCAL FAR * WSAGetLastError) (void);
	BOOL(PASCAL FAR * WSAIsBlocking) (void);
	int (PASCAL FAR * WSACancelBlockingCall) (void);
	int (PASCAL FAR * WSAUnhookBlockingHook) (void);
	FARPROC(PASCAL FAR * WSASetBlockingHook) (FARPROC lpBlockFunc);
	int (PASCAL FAR * setsockopt) (SOCKET s, int level, int optname, const char FAR * optval, int optlen);
	int (PASCAL FAR * ioctlsocket) (SOCKET s, long cmd, u_long FAR *argp);
	int (PASCAL FAR * WSACancelAsyncRequest) (HANDLE hAsyncTaskHandle);
	int (PASCAL FAR * WSAAsyncSelect) (SOCKET s, HWND hWnd, u_int wMsg, long lEvent);
	HANDLE (PASCAL FAR * WSAAsyncGetHostByName) (HWND hWnd, u_int wMsg, const char FAR * name, char FAR * buf, int buflen);
	int (PASCAL FAR * getpeername) (SOCKET s, struct sockaddr FAR *name, int FAR * namelen);

	int (PASCAL FAR * getsockopt) (SOCKET s, int level, int optname, char FAR * optval, int FAR *optlen);
	char FAR * (PASCAL FAR * inet_ntoa) (struct in_addr in);
	u_long (PASCAL FAR * ntohl) (u_long netlong);
	int (PASCAL FAR * recvfrom) (SOCKET s, char FAR * buf, int len, int flags, struct sockaddr FAR *from, int FAR * fromlen);
	int (PASCAL FAR * select) (int nfds, fd_set FAR *readfds, fd_set FAR *writefds, fd_set FAR *exceptfds, const struct timeval FAR *timeout);
	int (PASCAL FAR * sendto) (SOCKET s, const char FAR * buf, int len, int flags, const struct sockaddr FAR *to, int tolen);
	int (PASCAL FAR * shutdown) (SOCKET s, int how);
	struct servent FAR * (PASCAL FAR * getservbyport) (int port, const char FAR * proto);
	struct servent FAR * (PASCAL FAR * getservbyname) (const char FAR * name, const char FAR * proto);
	struct protoent FAR * (PASCAL FAR * getprotobynumber) (int proto);
	struct protoent FAR * (PASCAL FAR * getprotobyname) (const char FAR * name);
	void (PASCAL FAR * WSASetLastError) (int iError);
	HANDLE (PASCAL FAR * WSAAsyncGetServByName) (HWND hWnd, u_int wMsg, const char FAR * name, const char FAR * proto, char FAR * buf, int buflen);
	HANDLE (PASCAL FAR * WSAAsyncGetServByPort) (HWND hWnd, u_int wMsg, int port, const char FAR * proto, char FAR * buf, int buflen);
	HANDLE (PASCAL FAR * WSAAsyncGetProtoByName) (HWND hWnd, u_int wMsg, const char FAR * name, char FAR * buf, int buflen);
	HANDLE (PASCAL FAR * WSAAsyncGetProtoByNumber) (HWND hWnd, u_int wMsg, int number, char FAR * buf, int buflen);
	HANDLE (PASCAL FAR * WSAAsyncGetHostByAddr) (HWND hWnd, u_int wMsg, const char FAR * addr, int len, int type, char FAR * buf, int buflen);
	int (PASCAL FAR * __WSAFDIsSet) (SOCKET s, fd_set FAR *set);

	INT (PASCAL FAR * EnumProtocolsA)		(LPINT lpiProtocols, LPVOID lpProtocolBuffer, LPDWORD lpdwBufferLength);
	INT (PASCAL FAR * EnumProtocolsW)		(LPINT lpiProtocols, LPVOID lpProtocolBuffer, LPDWORD lpdwBufferLength);
	INT (PASCAL FAR * GetAddressByNameA)	(DWORD dwNameSpace, LPGUID lpServiceType, LPSTR lpServiceName, LPINT lpiProtocols, DWORD dwResolution, LPSERVICE_ASYNC_INFO lpServiceAsyncInfo, LPVOID lpCsaddrBuffer, LPDWORD lpdwBufferLength, LPSTR lpAliasBuffer, LPDWORD lpdwAliasBufferLength);
	INT (PASCAL FAR * GetAddressByNameW)	(DWORD dwNameSpace, LPGUID lpServiceType, LPWSTR lpServiceName,
										    LPINT lpiProtocols, DWORD dwResolution, LPSERVICE_ASYNC_INFO lpServiceAsyncInfo,
										    LPVOID lpCsaddrBuffer, LPDWORD lpdwBufferLength, LPWSTR lpAliasBuffer, LPDWORD lpdwAliasBufferLength);	
	INT (PASCAL FAR * GetNameByTypeA)		(LPGUID lpServiceType, LPSTR lpServiceName, DWORD dwNameLength);
	INT (PASCAL FAR * GetNameByTypeW)		(LPGUID lpServiceType, LPWSTR lpServiceName, DWORD dwNameLength);
	INT (PASCAL FAR * GetServiceA)			(DWORD dwNameSpace, LPGUID lpGuid, LPSTR lpServiceName, DWORD dwProperties, LPVOID lpBuffer,
										    LPDWORD lpdwBufferSize, LPSERVICE_ASYNC_INFO lpServiceAsyncInfo);
	INT (PASCAL FAR * GetServiceW)			(DWORD dwNameSpace, LPGUID lpGuid, LPWSTR lpServiceName, DWORD dwProperties, LPVOID lpBuffer,
										    LPDWORD lpdwBufferSize, LPSERVICE_ASYNC_INFO lpServiceAsyncInfo);
	INT (PASCAL FAR * GetTypeByNameA)		(LPSTR lpServiceName, LPGUID lpServiceType);
	INT (PASCAL FAR * GetTypeByNameW)		(LPWSTR lpServiceName, LPGUID lpServiceType);
	INT (PASCAL FAR * SetServiceA)			(DWORD dwNameSpace, DWORD dwOperation, DWORD dwFlags, LPSERVICE_INFOA lpServiceInfo,
										    LPSERVICE_ASYNC_INFO lpServiceAsyncInfo, LPDWORD lpdwStatusFlags);
	INT (PASCAL FAR * SetServiceW)			(DWORD dwNameSpace, DWORD dwOperation, DWORD dwFlags, LPSERVICE_INFOW lpServiceInfo,
										    LPSERVICE_ASYNC_INFO lpServiceAsyncInfo, LPDWORD lpdwStatusFlags);
	BOOL (PASCAL FAR * TransmitFile)		(SOCKET hSocket, HANDLE hFile, DWORD nNumberOfBytesToWrite, DWORD nNumberOfBytesPerSend,
										    LPOVERLAPPED lpOverlapped, LPTRANSMIT_FILE_BUFFERS lpTransmitBuffers, DWORD dwFlags);	
	int (PASCAL FAR * WSARecvEx)			(SOCKET s, char FAR * buf, int len, int *flags);	

	void (PASCAL FAR * WsControl)			();
	void (PASCAL FAR * closesockinfo)		();
	void (PASCAL FAR * Arecv)				();
	void (PASCAL FAR * Asend)				();
	void (PASCAL FAR * WSHEnumProtocols)	();
	void (PASCAL FAR * inet_network)		();
	void (PASCAL FAR * getnetbyname)		();
	void (PASCAL FAR * rcmd)				();
	void (PASCAL FAR * rexec)				();
	void (PASCAL FAR * rresvport)			();
	void (PASCAL FAR * sethostname)			();
	void (PASCAL FAR * dn_expand)			();
	void (PASCAL FAR * s_perror)			();
	void (PASCAL FAR * NPLoadNameSpaces)	();
};

struct LocalData {
	HANDLE	hWinsock;

	BOOL	bInCall;
};

#ifdef	GLOBAL
#define	EXTERN
#else
#define	EXTERN extern
#endif

EXTERN	DWORD					TlsIndex;
EXTERN	struct FunctionTable	gft;

#undef	EXTERN
