//
//	OTPWSK32
//
//	Copyright (C) 1996,1997 NEC Corporation
//	All rights reserved.
//  Authos(s): Mizukoshi, Yasuhiro <mizukosi@ccs.mt.nec.co.jp>
//

//	    $Archive: /sotools/otpsock/wsock32/winsock.c $
//			$Revision: 2 $
//			$Date: 98/11/25 12:59p $
static char VssID[] = "$Header: /sotools/otpsock/wsock32/winsock.c 2     98/11/25 12:59p Mizukosi $";

#include <windows.h>
#include <winsock.h>
#include "otpwsk32.h"
#include "../common.h"


SOCKET PASCAL FAR EXPORT
accept (SOCKET s, struct sockaddr FAR *addr, int FAR *addrlen)
{
	SOCKET	ret;

x_OutputDebugString("accept ");

	ret = gft.accept(s, addr, addrlen);

	return ret;
}

int PASCAL FAR EXPORT
bind (SOCKET s, const struct sockaddr FAR *addr, int namelen)
{
	int		ret;
	
x_OutputDebugString("bind ");

	ret = gft.bind(s, addr, namelen);

	return ret;

}

int PASCAL FAR EXPORT
closesocket (SOCKET s)
{
	int		ret;

x_OutputDebugString("closesocket ");

	ret = gft.closesocket(s);

	return ret;
}

int PASCAL FAR EXPORT
ioctlsocket (SOCKET s, long cmd, u_long FAR *argp)
{
	int		ret;
	
x_OutputDebugString("ioctlsocket ");

	ret = gft.ioctlsocket(s, cmd, argp);

	return ret;
}

int PASCAL FAR EXPORT
getpeername (SOCKET s, struct sockaddr FAR *name, int FAR * namelen)
{
	int		ret;
	
x_OutputDebugString("getpeername ");
	
	ret = gft.getpeername(s, name, namelen);

	return ret;
}

int PASCAL FAR EXPORT
getsockname (SOCKET s, struct sockaddr FAR *name, int FAR * namelen)
{
	int		ret;
	
x_OutputDebugString("getsockname ");

	ret = gft.getsockname(s, name, namelen);

	return ret;
}

int PASCAL FAR EXPORT
getsockopt (SOCKET s, int level, int optname, char FAR * optval,
    int FAR *optlen)
{
	int		ret;
	
x_OutputDebugString("getsockopt ");

	ret = gft.getsockopt(s, level, optname, optval, optlen);

	return ret;
}

u_long PASCAL FAR EXPORT
htonl (u_long hostlong)
{
	u_long	ret;
	
x_OutputDebugString("htonl ");

	ret = gft.htonl(hostlong);

	return ret;
}

u_short PASCAL FAR EXPORT 
htons (u_short hostshort)
{
	u_short	ret;
	
x_OutputDebugString("htons ");

	ret = gft.htons(hostshort);

	return ret;
}

unsigned long PASCAL FAR EXPORT
inet_addr (const char FAR * cp)
{
	unsigned long	ret;
	
x_OutputDebugString("inet_addr ");

	ret = gft.inet_addr(cp);

	return ret;
}

char FAR * PASCAL FAR EXPORT
inet_ntoa (struct in_addr in)
{
	char				*ret;
	
x_OutputDebugString("inet_ntoa ");

	ret = gft.inet_ntoa(in);

	return ret;
}

int PASCAL FAR EXPORT
listen (SOCKET s, int backlog)
{
	int		ret;
	
x_OutputDebugString("listen ");
	
	ret = gft.listen(s, backlog);

	return ret;
}

u_long PASCAL FAR EXPORT
ntohl (u_long netlong)
{
	u_long	ret;
	
x_OutputDebugString("ntohl ");
	
	ret = gft.ntohl(netlong);

	return ret;
}

u_short PASCAL FAR EXPORT
ntohs (u_short netshort)
{
	u_short	ret;
	
x_OutputDebugString("ntohs ");

	ret = gft.ntohs(netshort);

	return ret;
}


int PASCAL FAR EXPORT
recvfrom (SOCKET s, char FAR * buf, int len,
    int flags, struct sockaddr FAR *from, int FAR * fromlen)
{
	int		ret;
	
x_OutputDebugString("recvfrom ");
	
	ret = gft.recvfrom(s, buf, len, flags, from, fromlen);

	return ret;
}

int PASCAL FAR EXPORT
select (int nfds, fd_set FAR *readfds,
    fd_set FAR *writefds, fd_set FAR *exceptfds,
    const struct timeval FAR *timeout)
{
	int ret;

x_OutputDebugString("select ");

	ret = gft.select(nfds, readfds, writefds, exceptfds, timeout);

	return ret;
}

int PASCAL FAR EXPORT
sendto (SOCKET s, const char FAR * buf, int len,
    int flags, const struct sockaddr FAR *to, int tolen)
{
	int		ret;
	
x_OutputDebugString("sendto ");
	
	ret = gft.sendto(s, buf, len, flags, to, tolen);

	return ret;
}

int PASCAL FAR EXPORT
setsockopt (SOCKET s, int level, int optname,
    const char FAR * optval, int optlen)
{
	int		ret;

x_OutputDebugString("setsockopt ");
	
	ret = gft.setsockopt(s, level, optname, optval, optlen);

	return ret;
}

int PASCAL FAR EXPORT
shutdown (SOCKET s, int how)
{
	int		ret;

x_OutputDebugString("shutdown ");

	ret = gft.shutdown(s, how);

	return ret;
}

SOCKET PASCAL FAR EXPORT
socket (int af, int type, int protocol)
{
	SOCKET s;

x_OutputDebugString("socket ");

	s = gft.socket(af, type, protocol);

	return s;
}



/* Database functions */

struct hostent FAR * PASCAL FAR EXPORT
gethostbyaddr(const char FAR * addr, int len, int type)
{
	struct hostent FAR	*ret;
	
x_OutputDebugString("gethostbyaddr ");

	ret = gft.gethostbyaddr(addr, len, type);

	return ret;
}

struct hostent FAR * PASCAL FAR EXPORT
gethostbyname(const char FAR * name)
{
	struct hostent FAR	*ret;
	
x_OutputDebugString("gethostbyname ");

	ret = gft.gethostbyname(name);
	
	return ret;
}

int PASCAL FAR EXPORT
gethostname (char FAR * name, int namelen)
{
	int		ret;

x_OutputDebugString("gethostname ");
	
	ret = gft.gethostname(name, namelen);

	return ret;
}

struct servent FAR * PASCAL FAR EXPORT
getservbyport(int port, const char FAR * proto)
{
	struct servent FAR	*ret;
	
x_OutputDebugString("getservbyport ");

	ret = gft.getservbyport(port, proto);

	return ret;
}

struct servent FAR * PASCAL FAR EXPORT
getservbyname(const char FAR * name, const char FAR * proto)
{
	struct servent FAR	*ret;
	
x_OutputDebugString("getservbyname ");

	ret = gft.getservbyname(name, proto);
	
	return ret;
}

struct protoent FAR * PASCAL FAR EXPORT
getprotobynumber(int proto)
{
	struct protoent FAR	*ret;
	
x_OutputDebugString("getprotobynumber ");

	ret = gft.getprotobynumber(proto);

	return ret;
}

struct protoent FAR * PASCAL FAR EXPORT
getprotobyname(const char FAR * name)
{
	struct protoent FAR	*ret;
	
x_OutputDebugString("getprotobyname ");

	ret = gft.getprotobyname(name);

	return ret;
}



/* Microsoft Windows Extension functions */

int PASCAL FAR EXPORT
WSACleanup(void)
{
	int		ret;

x_OutputDebugString("WSACleanup ");

	ret = gft.WSACleanup();

	return ret;
}

void PASCAL FAR EXPORT
WSASetLastError(int iError)
{

x_OutputDebugString("WSASetLastError ");

	gft.WSASetLastError(iError);

	return;
}

int PASCAL FAR EXPORT
WSAGetLastError(void)
{
	int ret;

x_OutputDebugString("WSAGetLastError ");

	ret = gft.WSAGetLastError();

	return ret;
}

BOOL PASCAL FAR EXPORT
WSAIsBlocking(void)
{
	BOOL	ret;

x_OutputDebugString("WSAIsBlocking ");

	ret = gft.WSAIsBlocking();

	return ret;
}

int PASCAL FAR EXPORT
WSAUnhookBlockingHook(void)
{
	int		ret;

x_OutputDebugString("WSAUnhookBlockingHook ");

	ret = gft.WSAUnhookBlockingHook();

	return ret;
}

FARPROC PASCAL FAR EXPORT
WSASetBlockingHook(FARPROC lpBlockFunc)
{
	FARPROC	ret;

x_OutputDebugString("WSASetBlockingHook ");

	ret = gft.WSASetBlockingHook(lpBlockFunc);

	return ret;
}

int PASCAL FAR EXPORT
WSACancelBlockingCall(void)
{
	int		ret;

x_OutputDebugString("WSACancelBlockingCall ");

	ret = gft.WSACancelBlockingCall();

	return ret;
}

HANDLE PASCAL FAR EXPORT 
WSAAsyncGetServByName(HWND hWnd, u_int wMsg, const char FAR * name,
    const char FAR * proto, char FAR * buf, int buflen)
{
	HANDLE	ret;

x_OutputDebugString("WSAASyncGetServByName ");

	ret = gft.WSAAsyncGetServByName(hWnd, wMsg, name, proto, buf, buflen);

	return ret;
}

HANDLE PASCAL FAR EXPORT
WSAAsyncGetServByPort(HWND hWnd, u_int wMsg, int port,
    const char FAR * proto, char FAR * buf, int buflen)
{
	HANDLE	ret;

x_OutputDebugString("WSAASyncGetServByPort ");

	ret = gft.WSAAsyncGetServByPort(hWnd, wMsg, port, proto, buf, buflen);

	return ret;
}

HANDLE PASCAL FAR EXPORT
WSAAsyncGetProtoByName(HWND hWnd, u_int wMsg, const char FAR * name,
    char FAR * buf, int buflen)
{
	HANDLE	ret;

x_OutputDebugString("WSAASyncGetProtoByName ");

	ret = gft.WSAAsyncGetProtoByName(hWnd, wMsg, name, buf, buflen);

	return ret;
}

HANDLE PASCAL FAR EXPORT
WSAAsyncGetProtoByNumber(HWND hWnd, u_int wMsg, int number,
    char FAR * buf, int buflen)
{
	HANDLE	ret;

x_OutputDebugString("WSAAsyncGetProtoByNumber ");

	ret = gft.WSAAsyncGetProtoByNumber(hWnd, wMsg, number, buf, buflen);

	return ret;
}

HANDLE PASCAL FAR EXPORT
WSAAsyncGetHostByName(HWND hWnd, u_int wMsg, const char FAR * name,
    char FAR * buf, int buflen)
{
	HANDLE	ret;

x_OutputDebugString("WSAAsyncGetHostByName ");

	ret = gft.WSAAsyncGetHostByName(hWnd, wMsg, name, buf, buflen);

	return ret;
}

HANDLE PASCAL FAR EXPORT
WSAAsyncGetHostByAddr(HWND hWnd, u_int wMsg, const char FAR * addr,
    int len, int type, char FAR * buf, int buflen)
{
	HANDLE	ret;

x_OutputDebugString("WSAAsyncgetHostByAddr ");

	ret = gft.WSAAsyncGetHostByAddr(hWnd, wMsg, addr, len, type, buf, buflen);

	return ret;
}

int PASCAL FAR EXPORT
WSACancelAsyncRequest(HANDLE hAsyncTaskHandle)
{																				
	int		ret;

x_OutputDebugString("WSACancelAsyncRequest ");

	ret = gft.WSACancelAsyncRequest(hAsyncTaskHandle);

	return ret;
}

/////////////////////////////////////////////
//	WSAAsyncSelect
//
int PASCAL FAR EXPORT
WSAAsyncSelect(SOCKET s, HWND hWnd, u_int wMsg, long lEvent)
{
	int		ret;

x_OutputDebugString("WSAAsyncSelect ");

	ret = gft.WSAAsyncSelect(s, hWnd, wMsg, lEvent);

	return ret;
}


int PASCAL FAR EXPORT __WSAFDIsSet(SOCKET s, fd_set FAR *set)
{
	int		ret;

x_OutputDebugString("__WSAFDIsSet ");

	ret = gft.__WSAFDIsSet(s, set);

	return ret;
}
